#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var commander_1 = require("commander");
var index_1 = require("../index");
var package_json_1 = __importDefault(require("../../package.json"));
var program = new commander_1.Command();
program
    .version(package_json_1.default.version)
    .usage('</path/to/src/pages>')
    .option('-b, --baseDir <dir>', 'default: targetDir')
    .option('-i, --ignore <globs...>', 'ex. **/*.stories.*')
    .option('-p, --importPrefix <prefix>', 'default: @/pages')
    .parse(process.argv);
if (program.args.length === 0) {
    program.help();
}
else {
    var options = program.opts();
    var targetDir = path_1.default.resolve(process.cwd(), program.args[0]);
    var baseDir = path_1.default.resolve(process.cwd(), options.baseDir || targetDir);
    var sourceCode = index_1.generate({
        targetDir: targetDir,
        baseDir: baseDir,
        importPrefix: (_a = options.importPrefix) !== null && _a !== void 0 ? _a : '@/pages',
        ignorePatterns: options.ignore,
    });
    console.log(sourceCode);
}
