"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generate = void 0;
var compare_func_1 = __importDefault(require("compare-func"));
var utils_1 = require("./utils");
var ts = __importStar(require("typescript"));
var typescript_1 = require("typescript");
var generateRouteConfig_1 = require("./generators/generateRouteConfig");
var generateRoutes_1 = require("./generators/generateRoutes");
var generateSourceHead_1 = require("./generators/generateSourceHead");
var generateTypeCode_1 = require("./generators/generateTypeCode");
// 拡張子を取り除く
// .replace(/^(.*)\.(js|jsx|ts|tsx)$/, '$1')
function genRouteMetaData(componentPath) {
    var urlPath = componentPath
        // 末尾の/index.{js,jsx,ts,tsx} を消す
        .replace(/^(.*)\/index\.(js|jsx|ts|tsx)$/, '$1');
    var isLastOptional = /^(.*)\.(js|jsx|ts|tsx)$/.test(urlPath);
    if (isLastOptional) {
        urlPath = urlPath.replace(/^(.*)\.(js|jsx|ts|tsx)$/, '$1');
    }
    return _calcRouteMetaData({
        path: urlPath,
        isLastOptional: isLastOptional,
        componentPath: componentPath.replace(/^(.*)\.(js|jsx|ts|tsx)$/, '$1'),
        urlPath: urlPath === '' ? '/' : urlPath,
    });
}
// hoge/fuga/[piyo]/[piyopiyo] => hoge/fuga/:piyo/:piyopiyo
function _calcRouteMetaData(metaData) {
    var _a;
    var result = /^(.*)\[(.*?)\](.*)$/.exec(metaData.urlPath);
    if (!result) {
        if (metaData.isLastOptional) {
            var items = metaData.urlPath.split('/');
            items[items.length - 1] = items[items.length - 1] + "?";
            metaData = __assign(__assign({}, metaData), { urlPath: items.join('/') });
        }
        return metaData;
    }
    result.reverse();
    var isRest = false;
    var slug = /^\.\.\.(.*)$/.exec(result[1]);
    if (slug) {
        isRest = true;
        result[1] = slug[1];
    }
    return _calcRouteMetaData(__assign(__assign({}, metaData), { urlPath: isRest
            ? result[2] + ":" + result[1] + "(.*)"
            : result[2] + ":" + result[1] + result[0], slugs: __spreadArray(__spreadArray([], ((_a = metaData.slugs) !== null && _a !== void 0 ? _a : [])), [
            {
                name: result[1],
                isRest: isRest,
            },
        ]) }));
}
function generate(params) {
    var targetDir = params.targetDir, baseDir = params.baseDir, importPrefix = params.importPrefix, _a = params.ignorePatterns, ignorePatterns = _a === void 0 ? [] : _a;
    var routes = utils_1.globSync(utils_1.escapeFilePath(targetDir) + "/**/*", ignorePatterns)
        .map(function (filePath) {
        var result = new RegExp("^" + baseDir + "(.*)$").exec(filePath);
        utils_1.assertsHasValue(result, "There can't be an error here. filePath: " + filePath);
        return result[1];
    })
        .map(function (componentPath) { return genRouteMetaData(componentPath); })
        .sort(compare_func_1.default('urlPath'))
        .reverse();
    var printer = ts.createPrinter({ newLine: ts.NewLineKind.LineFeed });
    return printer.printNode(ts.EmitHint.Unspecified, typescript_1.factory.createSourceFile(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], generateSourceHead_1.generateSourceHead()), generateTypeCode_1.generateTypeCode(routes)), generateRouteConfig_1.generateRouteConfig(routes, importPrefix)), generateRoutes_1.generateRoutes(routes)), typescript_1.factory.createToken(ts.SyntaxKind.EndOfFileToken), ts.NodeFlags.None), ts.createSourceFile('', '', ts.ScriptTarget.ESNext, false, ts.ScriptKind.TSX));
}
exports.generate = generate;
