"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.escapeFilePath = exports.globSync = exports.assertsHasValue = void 0;
var glob_1 = __importDefault(require("glob"));
function assertsHasValue(value, errorMessage) {
    if (value === null || value === undefined) {
        throw new Error(errorMessage);
    }
}
exports.assertsHasValue = assertsHasValue;
function globSync(patterns, ignorePatterns) {
    if (typeof patterns === 'string') {
        patterns = [patterns];
    }
    return patterns.reduce(function (acc, pattern) {
        return acc.concat(glob_1.default.sync(pattern, { nodir: true, ignore: ignorePatterns }));
    }, []);
}
exports.globSync = globSync;
var targets = [' ', '[', ']'];
function escapeFilePath(filePath) {
    targets.forEach(function (w) {
        filePath = filePath.split(w).join("\\" + w);
    });
    return filePath;
}
exports.escapeFilePath = escapeFilePath;
